<?php

/* DAT/EXPORT.PHP - Admin code for export and import posts

This has had it's interface changed to be slightly more understandable than 
before. (It was a bit goofy yet had some qualities that I regret eliminating.) 
Eventually much more will be able to be done here... 

Although the directory is the same for export and import there are two defines 
because of the mechanism used (and the point of view). 

Export is from the database to the directory; import is from the directory into 
the database; upload is from a local computer to the directory; download is not 
done yet. 

Upload may at first seem odd, but it works only when running on localhost and 
import files exist locally -- then those files can be uploaded to the remote 
site (which must match in location unless the define is changed).
*/

define('IMPFTP','../ftp.ini');	// a LOCAL FTP.INI file for uploading files 
define('EXPDIR',dirname(config('importdir')).'/');
define('IMPDIR',config('basedir').dirname(config('importdir')).'/');


/* export - actually, export and import and upload to website */

function export($expcmd) {

	$op = getvar('op');
	$arg = getvar('arg');
	$config = config();
	$section = config('arg');
	$local = function_exists('ftp_connect') && config('local') 
		&& file_exists(IMPFTP);
	debug(EXPDIR);

$query = <<<HTML
<form name="query" method="get" action="{\$config['selfurl']}">
<input type="submit" value="\$expcmd">
<input type="hidden" name="op" value="export">
<input type="hidden" name="expcmd" value="\$expcmd">
<input type="hidden" name="arg" value="\$arg">
</form>

HTML;

echo <<<HTML
<div class="menu">
<span>
<span class="help" style="cursor:default;"></span>
<p>The <b>export</b> command will write all of the posts of the current section, 
<b>$section</b>, to text files in the <tt>import</tt> directory.<br><br>
If text files exist in the <tt>import</tt> directory the <b>import</b> command 
will append them all into the current sections's posts.<br><br>
This can be used to transfer one section's posts to another by selecting one 
section for export, and then another section for import.
</p>
</span>
</div>
HTML;

	$messages = $GLOBALS['messages'];

	// if export command not defined display menu

	if ($expcmd == '') {

		$n = export_export(1);
		echo "There are $n records in section <b><tt>$section</tt></b> ".
		"for export.<br><br>";
		if ($n) {
			$expcmd = "export";
			eval(shit_show($query));
		}

		$n = export_import(1);
		$s = ($local) ? '/upload' : '';
		echo "<p>There are $n files available for import$s.</p>";
		if ($n) {
			$expcmd = "import";
			eval(shit_show($query));
			$expcmd = "delete";
			eval(shit_show($query));
			if ($local) {
				$expcmd = "upload";
				eval(shit_show($query));
			}
		}

		// prepare the final button
		$HTML = "";
		$op = "read";
		$button = "done";
	}
	else {
		// shall  we  play  a  game? (or ask a question)
		if (!isset($_POST['yes'])) {
			$preamble = export_str('cmds',$expcmd);
			$action = export_str('actn',$expcmd);
			eval(shit_show($messages['confirm']));
		}
		// or shall we do the command function?
		else {
			$HTML = "";
			$func = export_str('func',$expcmd);
			$n = $func();
			debug("$func = $n");
			if ($n !== '')
				echo "$n ". export_str('sum',$expcmd);
			else
				echo "Unable to connect."; //error('php_error');
		}
		$button = "back";
	}

	if (isset($HTML))
echo <<<HTML
<p>$HTML</p>
<form title="$formtitle" name="done" method="get" action="{$config['selfurl']}">
<button type="submit" value="done">$button</button>
<input type="hidden" name="op" value="$op">
<input type="hidden" name="arg" value="$arg">
</form>
HTML;
}


/* export_import - get importable files or import files */

function export_import($cmd = 0) {

	$files = glob(EXPDIR.'*.txt');
	if (!$files)
		return 0;

	if ($cmd)
		return count($files);

	echo 'Importing... ';
	natsort($files);
	foreach ($files as $file) {
		echo export_file($file);
		$data = file_get_contents($file);
		writerecord($data);
	}
	return count($files);
}

/* export_export - get exportable records or export records */

function export_export($cmd = 0) {

	$recs = dblistrecords();
	if (!$recs) {
		echo 'no records found';
		return '';
	}

	if ($cmd)
		return count($recs);

	echo 'Saving... ';
	$c = 1;
	natsort($recs);
	foreach ($recs as $id) {
		$record = dbreadrecord($id);
		echo "$id ";
		$file = EXPDIR."$c.txt";
		file_put_contents($file,recordtostring($record));
		++$c;
	}

	return $c - 1;
}

/* export_delete - delete importable files */

function export_delete() {

	$files = glob(EXPDIR.'*.txt');
	if (!$files) {
		echo 'no files found';
		return '';
	}

	echo 'Deleting... ';
	foreach ($files as $file) {
		echo export_file($file);
		unlink($file);
	}

	return count($files);
}

/* export_upload - upload import files */

function export_upload() {

	$files = glob(EXPDIR.'*.txt');
	if (!$files) {
		echo 'no files found';
		return '';
	}

	$ftp = parse_ini_file(IMPFTP);
	$n = '';
	$fp = ftp_connect($ftp['site'],21,30);
// note 1
	if ($fp) {
		$res = ftp_login($fp,$ftp['user'],$ftp['pass']);
		if ($res) {
			ftp_pasv($fp,TRUE); 
			echo 'Uploading... ';
			$n = 0;
			foreach ($files as $file) {
				$f = str_replace(EXPDIR,'',$file);
				echo $f.' ';
				if (ftp_put($fp,IMPDIR.$f,$file,FTP_ASCII) == FALSE)
					break;	// error check not really necessary
				$n++;
			}
		}
		ftp_close($fp);
	}

	return $n;
}

/* export_file - remove path and extension */

function export_file($file) {

	return str_replace('.txt','',str_replace(EXPDIR,'',$file)).' ';
}

/* export_str - a very odd function; note 2 */

function export_str($type, $cmd) {
	$section = config('arg');

$cmds = array(
'export' => "Would you like to save ALL <b>$section</b> posts to the 'import' directory?",
'import' => "Would you like to import ALL import files into <b>$section</b>?",
'delete' => "Would you like to delete ALL files in the <tt>import</tt> directory?",
'upload' => "Would you like to upload ALL files in the <tt>import</tt> directory?",
);

$actn = array(
'export' => "export posts",
'import' => "import files",
'delete' => "delete import files",
'upload' => "upload import files",
);

$func = array(
'export' => 'export_export',
'import' => 'export_import',
'delete' => 'export_delete',
'upload' => 'export_upload',
);

$sum = array(
'export' => "records written",
'import' => "files imported",
'delete' => "files deleted",
'upload' => "files uploaded",
);

	$t = $$type; return $t[$cmd];
}

/*
I probably bother people by all these notes, but these comments can be deleted 
which is partly why they are in the form of footnotes.
NOTES
0. Some functions here overload their return value, something I do fairly 
often. Probably first encountered it is annoying, but overall it can be useful.
1. I generally prefer to avoid unnecessary indents, sometimes even at the 
expense of multiple return points, however, this time, multiple return points 
would have resulted in code duplication, which I also like to avoid.
2. This results in less code at the expense of slight obfuscation. You should 
have seen the last version... (Oh, I like making related variables the same 
number of characters, and I almost got away with all being four.)
*/
