<?php

/* DAT/SETUP.PHP - write several core defines to DAT/DEFINES.PHP

This code writes the required credentials, account name/password/salts as 
defines. And also creates the MySQL database and tables, optionally importing 
posts or creating "first posts". Based on an ad hoc design, and the result of 
the combining of two different peices of code it is kind of inefficient, even 
at only 300 lines.

Other notes. The file being writeable will be just fine as all of the code is 
just a simple API and the location is protected by .htacces. A further 
safegaurd could be to change the location of the file as it is a define.
Storing the salt along side the password is simply a convienence as an 
encrypted password contains the salt.
*/

define('DEFINESFILE','dat/defines.php');
define('DEFINES_DEFINES','ad_name,ad_pass,db_user,db_pass,db_name,'.
	'salt1,salt2,salt3,filemode,import,nofirst');


/* setup - write data, from Admin form, for names, passwords, salts etc */

function setup() {

	userlogout();				// this deletes cookie (note 1)

	$setuphtml = 'htm/admin/setup.htm';
	$file = DEFINESFILE;
	$html = html();
	$config = config();
	$arg = $status = $formtitle = '';	// for templates

	// POST data and the POST macro; see INC/GETPOST.PHP
	$post = DEFINES_DEFINES;
	eval(POST_);

	$button = postvar('button');

	if ($salt1 == '') $salt1 = '$5$'.randomstring(16);
	if ($salt2 == '') $salt2 = '$5$'.randomstring(16);
	if ($salt3 == '') $salt3 = randomstring(16);

	eval(shit_file('htm/admin/open.html'));

	$f = is_writeable($file);
	if (!$f) {
		echo "<tt>The file '$file' does not have write permission ".
		"so the settings cannot be saved. (A PHP script cannot ".
		"change a file's permissions.)</tt><br><br>";
	}

	else
	if ($button == 'write' || $button == 'test') {
		$e = $m = '';

		if (!userid($ad_name))
			$e = 'Improper Login ID.';
		if (!$ad_name || !$ad_pass)
			$e = 'Admin account name and password required.';
		if (!$salt1 || !$salt2 || !$salt3)
			$e = 'Password salts required.';
		if (!$filemode && (!$db_user || !$db_pass || !$db_name))
			$e = 'MySQL parameters required.';

		if (!$e) {
			$e = checkpassword($ad_pass);
			if ($filemode) {
				if (!is_writable($t=config('importdir')))
					$e = "Do not have write permission to '$t'.";
			}
			else {
				if (!dbconnect($db_user,$db_pass))
					$e = dberror(TRUE);
# can check GRANTS here? (thought could but no longer sure how)
				if (!$e && !dbselect($db_name))
					$status = "Database $db_name not found (will ".
					     "be created if user has create rights).";
			}
		}

		if ($e)
			$status = $e;
		else
		if ($button == 'test' && !$status)
			$status = 'Data appears valid.';

		// if okay write file

		if (!$e && $button == 'write') {
			$status = setup_save($file);
			if ($status == '') {
				setup_all();
				$message = 'okayfine';
			}
		}
	}

	if ($filemode) $filemode = 'checked';
	if ($import) $import = 'checked';
	if ($nofirst) $nofirst = 'checked';

	if (isset($message))
		eval(shit_show(messages($message)));
	else
		eval(shit_file($setuphtml));

	eval(shit_file('htm/admin/close.html'));
}

/* setup_all - create all tables */

function setup_all() {

	foreach (config('sections') as $section => $na) {
		if ($section == '')
			$section = 'root';
		if (defined('FILEMODE'))
			setup_filemode($section,config('allowcomments'));
		else
			setup_tables($section);
	}
	if (!defined('FILEMODE'))
		setup_user_tables();
}


/* setup_save - save data to file */

function setup_save($file) {

	$post = DEFINES_DEFINES;
	eval(POST_);
	$posts = explode(',',$post);
	$ad_pass = crypt($ad_pass,$salt1);

	// special these if "" (note 1)
	if (!$import) array_delete($posts,'import');
	if (!$nofirst) array_delete($posts,'nofirst');
	if (!$filemode)
		array_delete($posts,'filemode');
	else {
		array_delete($posts,'db_user');
		array_delete($posts,'db_pass');
		array_delete($posts,'db_name');
	}

	// (some of) these needed later (note 2)
	foreach ($posts as $_)
		define(strtoupper($_),$$_);

	// select (and possibly create) the database
# not quite right to check/create here ("code logic error"), but ...
	if (!$filemode && dbselect($db_name,TRUE) == FALSE) {
		$msg = dberror();
		debug($msg);
		return $msg;
	}

	// write the defines file
	$fd = setup_reset($file,FALSE);
	if (!$fd)
		return "unable to write to '$file'.";

	echo "Writing $file file...<br><br>";
	foreach ($posts as $_) {
		echo strtoupper($_)." ".$$_."<br>";
		fwrite($fd,"define('".strtoupper($_)."','".$$_."');\n");
	}
	echo '<br>';
	fclose($fd);

	return '';
}

/* setup_update - update password */

function setup_update($file, $password) {

	$posts = explode(',',DEFINES_DEFINES);

	if (!is_writeable($file))
		return "File '$file' is not writeable.";

	$fd = setup_reset($file,FALSE);
	if (!$fd)
		return "Unable to write to '$file'.";
# that would be really bad, but it really shouldn't happen

	$password = thiscrypt($password);

	echo "Updating $file file...";
	foreach ($posts as $_) {
		$_ = strtoupper($_);
		if (!defined($_))
			continue;
		if ($_ == "AD_PASS")
			$val = $password;
		else
			$val = constant($_);
		debug("writing '$_' = '$val'");
		fwrite($fd,"define('$_','$val');\n");
	}
	echo '<br>';
	fclose($fd);

	return '';
}

/* setup_reset - create empty file, return handle */

function setup_reset($file, $close = 0) {

	if ($fd = @fopen($file,'w')) {
		fwrite($fd,"<?php\n// this file gets written by the admin code\n\n");
		if ($close)
			fclose($fd);
	}
	return $fd;
}


/* setup_tables - post/comment tables */

function setup_tables($section) {

# kind of a kludge...
	$dir = dirname(config('importdir'));	// override dir
	$dir .= "/$section/";
	_mysql('table',$section);		// override table

	$import = (defined('IMPORT') && !config('noimport') && is_dir($dir));
	$installpost = (!defined('NOFIRST') && !config('noinstallpost'));

	// $db_table is referenced in the SQL data file

	$db_table = ($section) ? $section : config('arg');
	debug("'$section' '$dir' '$db_table'");

	// there are two tables in the $tables array, one for
	// posts and one for comments

	include 'dat/sql.php';		// the SQL table definitions ($tables)
# embedded includes add to bug potential but that one is just data needed 
# in the current scope (it defines $tables and references $db_table)

	foreach ($tables as $sql)
		if (dbquery($sql) == FALSE) {
			$msg = dberror();
			debug($msg);
		}

	if ($import) {
		if ($files = glob($dir.'*.txt')) {
			natsort($files);
			foreach ($files as $file)
				dbnewrecord(file_get_contents($file));
		}
	}
	else
	if ($installpost) {
		$date = date(config('datestr'));
		$data = "title: Title\ndate: $date\n\nContent goes here.\n";
		dbnewrecord($data);
	}
}

/* setup_user_tables - make the other tables */

function setup_user_tables() {

	debug('');

	include 'dat/sql.php';

	foreach ($user_tables as $sql)
		if (dbquery($sql) == FALSE)
			debug(dberror());

	$record = array("userid" => AD_NAME,
			"password" => AD_PASS,
			"body" => "Administrator Account"
			);
	dbuser('new',$record['userid'],$record);
}

/* setup_user_update - update Admin password */

// original file define NOT updated here (it's never referenced anyway)

function setup_user_update($password) {

	if (!($user = userput(AD_NAME,$password)))
		return usererror($user,AD_NAME);
	return '';
}

/* setup_filemode - create dir if needed */

function setup_filemode($name, $comments = TRUE) {

	$dbdir = dirname(config('importdir'));

	if (!is_dir($dir="$dbdir/$name")) {
		debug("'$dir' does not exist, creating");
		if (!mkdir($dir)) {
			debug("unable to create '$dir'");
# can also check "is writeable" but failure means the same thing
			return FALSE;
		}
		if ($comments) {
			$dir = "$dbdir/comments/$name";
			return mkdir($dir);
		}
	}

	return TRUE;
}


/* password - display password creation HTML form */

function password() {

	$status = '';
	$formtitle = '';
	$message = 'password';
	$html = html();
	$config = config();
	$arg = getvar('arg');
	$password = postvar('password');
	$password2 = postvar('password2');
	$button = postvar('button');

	eval(shit_file('htm/admin/open.html'));

	if ($button == 'update password') {
# unfortunately, the button also needs to be tested in ADMIN.PHP to get here 
# which is a design "imposition"

		$e = checkpassword($password,$password2);
		if ($e)
			$status = $e;
		else {
			if (defined('FILEMODE'))
				$status = setup_update(DEFINESFILE,$password);
			else
				$status = setup_user_update($password);

			if ($status == '') {
				userlogout();
				$message = 'passwordsaved';
			}
		}
	}

	eval(shit_show(messages($message)));
	eval(shit_file('htm/admin/close.html'));

// yes, yes, we know we are using a 'text' input, and yes, we are 
// displaying the password -- people should not be doing something like this 
// while in a public place (how's that for a cop out)
}


function checkpassword($p, $p2 = NULL) {

	$e = '';
	if ($p == '')
		$e = 'Password cannot be empty.';
	if ($p2 !== NULL && $p != $p2)
		$e = 'Passwords do not match.';
	return $e;

// used to have other tests here but we have a dislike for constraining 
// people, especially when testing
}

/*
note1 Cookies before and after setup can cause subtle problems. Changing the 
salt invalidates existing cookies, for example.
*/
