<?php

/* DAT/VISITORS.PHP - "Visitor" Admin management

   See also MOD/VISITORS.PHP. See DOC/README.HTML#VISITORS.

   This is just the beginning of managing "registered users" in an odd but 
   extremely simple way. This visitor stuff is quite small.

   (I'd really like to support something like Open ID, but that PHP code 
   available for it is incomprehensible (to me). And the Janrain Auth code is 
   as large as my entire code base. So, I am doing things totally different 
   as a form of rebellion... (if only within myself))
*/

// This is the second version and there will be at least one more reshape 
// before a full, standalone API is created.

function visitors() {

	print visitor_html('help',TRUE);

	$button = postvar('button');
	if ($button == 'cancel')
		unset($_GET['x']);

	if ($button == 'new' || $button == 'save') {
		$record = visitordata();		// merges $_POST data
# kind of uhggy... note1
		if ($c = visitorchksum($record))
			$status = "error in $c";
		else {
			if ($button == 'save')
				$res = visitorput($record);
			else {
				if (visitorget($record['from']))
					$status = 'user exists';
				else
					$res = visitorcreat($record);
			}
			if (isset($res) && !$res)
				$status = 'error!';
		}
		if (isset($status))
			$_GET['c'] = 1;
		else
			$status = 'saved!';
		echo '<b style="float:right;color:red;">'.$status.'</b>';
	}

	$html = html();
	$arg = getvar('arg');
	$op = 'visitors';

	$get = 'e,x,c,a';		// $_GET variables
	eval(GET_);

	if ($x) { // delete
		if (config('confirmdelete') && !isset($_POST['yes'])) {
			$preamble = "Preparing to delete visitor $x...";
			$action = "delete visitor $x?";
			eval(shit_show(messages('confirm')));
			return 1;
		}
		else {
			dbdelvisitor($x);
			$status = "visitor $x deleted!";
			echo '<b style="float:right;color:red;">'.$status.'</b>';
		}
	}

# the odd use of eval to get the HTML templates to work means that it looks 
# like there are many unused variables here; there are none

	else
	if ($c) { // create (in memory; still might be editing)
		if (!isset($record))
			$record = visitornew('','',NULL,0);
		htmlentitieize($record);
		eval(visitor_html('add'));
		return 1;
	}
	else
	if ($e !== '') { // edit (name of "0" is valid)
		$record = dbvisitor('read',$e);
		htmlentitieize($record);
		eval(visitor_html('edit'));
		return 1;
	}

	// make list of links to view visitors alphanumerically

	echo "<p>Select:";
	foreach (range('A','Z') as $l) {
		$m = strtolower($l) . strtoupper($l);
		$s = ($a == $l) ? 'vsel' : '';
		$c = dbvisitor('range',$m);
		$t = 'show visitors starting with '.$m;
		eval(visitor_html($c?'select':'none'));
	}

	$l = '0';
	$s = ($a == $l) ? 'vsel' : '';
	$c = dbvisitor('range','0-9');
	$t = 'show visitors starting with 0-9';
	eval(visitor_html($c?'select':'none'));

	$l = '*';
	$s = ($a == $l) ? 'vsel' : '';
	$c = dbvisitor('range','^a-zA-Z0-9');
	$t = 'show visitors starting with goofys';
	eval(visitor_html($c?'select':'none'));

	echo "</p>"; // end "<p>Select...

	if ($a !== '') {
		// convert a to a lookup range for query
		if ($a == '0')
			$r = '0-9';
		else
		if ($a == '*')
			$r = '^a-zA-Z0-9';
		else
			$r = strtolower($a).strtoupper($a);

		$visitor = dbvisitor('lookup',$r);

		if (!$visitor) {
			echo "No visitors found.<br>";
		}
		else {
			foreach($visitor as $record) {
				if ($c = visitorchksum($record)) {
					echo "corrupt record ($c) found<br>";
					continue;
				}
				// have to be careful to escape some data!
				$f = urlencode($record['from']);
				htmlentitieize($record);
				eval(visitor_html('display'));
			}
		}
	}

	eval(visitor_html('menu'));

	if (defined('SALTTEMP')) {
		echo '<br><tt>SALT2</tt> has not been defined (site not set-up)'.
		'<br>Records created now will be invalid after set-up.</p>';
	}

	return 0;
}


/* visitor_html - return eval formatted (print) HTML text */

# the following forms contain a mixture of GET and POST methods

function visitor_html($templ, $direct = FALSE) {

$htm['select'] = <<<'HTML'
 <a class='$s' title='$t' href='?op=$op&amp;a=$l'>$l</a><span style='font-size:90%;color:orange;vertical-align:1px;'>$c</span>
HTML;

$htm['none'] = ' $l';

$htm['display'] = <<<'HTML'

<a class='x' href='?op=$op&amp;a=$a&amp;x=$f' title="delete visitor {$record['from']}{$html['confirmdelete']}"></a>
<b><a href='?op=$op&amp;a=$a&amp;e=$f' title="edit visitor {$record['from']}">{$record['from']}</a></b>
<span style='color:darkblue;'>'{$record['code']}'</span>
<span style='color:darkblue;'>{$record['body']}</span>
<br class='clear'>
HTML;

$htm['edit'] = <<<'HTML'

<b>Edit Visitor: </b>'{$record['from']}'<br><br>
<form class='vedit' method='post' action='{$config['selfurl]']}?op=$op&amp;a=$a'>
<input type='hidden' name='from' value="{$record['from']}">
<p>code: <input name='code' value="{$record['code']}"> enter new code to update (without salt prefix)</p>
<span style='float:left;margin-right:.6em;'>body: </span><textarea rows='5' name='body'>{$record['body']}</textarea>
<div class='buttons'>
<button name='button' value='save' title='save changes'>save</button>
<button type='cancel' title='cancel changes'>cancel</button>
</div>
</form>
HTML;

$htm['add'] = <<<'HTML'

<b>Create Visitor</b><br><br>
<form class='vedit' method='post' action='{$config['selfurl]']}?op=$op&amp;a=$a'>
<p>from: <input name='from' value='{$record['from']}'></p>
<p>code: <input name='code' value='{$record['code']}'> plain text (will be encrypted)</p>
<span style='float:left;margin-right:.6em;'>body: </span><textarea rows='5' name='body'>{$record['body']}</textarea>
<div class='buttons'>
<button name='button' value='new' title='add visitor'>add</button>
<button type='cancel' title='cancel'>cancel</button>
</div>
</form>
HTML;
// a "close proximity" data duplication

$htm['menu'] = <<<'HTML'

<br>
<form style='float:left;margin-right:8px;' method='get' action='{$config['selfurl]']}'>
<button name='c' value='1' title='create new visitor record'>new</button>
<input type='hidden' name='op' value='$op'>
<input type='hidden' name='a' value='$a'>
</form>
<form method='get' action='{$config['selfurl]']}'>
<input type='submit' value='done' title='done with visitors'>
<input type='hidden' name='arg' value='$arg'>
</form>
HTML;

$htm['help'] = <<<HTML
<div class="menu">
<span>
<span class="help" style="cursor:default;"></span>
<p><b>Visitors</b> is an experimental way of tracking visitors who post comments. It needs to be enabled by <tt>visitorcode = 1</tt> in the <tt>CONFIG.INI</tt> file. See <a href="doc/readme.html#VISITORS" target="_blank">VISITORS</a>.<br><br>We plan on expanding this part of the code so that at some point it will have some meaning.
</p>
</span>
</div>
HTML;

	if ($direct)
		return $htm[$templ];
	return "print \"".str_replace('"','\\"',$htm[$templ])."\";";
}

/*
note1
This is a common coding construct, presenting an HTML form, validating the 
data on submit, saving the data if okay else re-displaying the form. But the 
visitor API, like many others, returns FALSE on error. If, instead, it returned 
a string on error the "test logic" here would be simpler...
*/
