<?php

/* HTM/FUNCTIONS.PHP - theme code

   This code gets called late by INDEX.PHP but before anything gets displayed.
   It is for making dynamic adjustments to the HTML depending on context or for 
   just making changes to the code.
*/


/* self initialize */

_config_functions();


/* in a function to not worry about polluting the global namespace */

function _config_functions() {

// one way to do this; see theme_function()
//	functions_html_adjust();

// example only:
	gmlp_add('inlines',array('/\bTHIS\b/' => '<b>THIS</b>',
		'/\bADMIN\b/' => '<a>Admin</a>',));
}

/* theme hook function */

// called by MOD/DISPLAY.PHP

function theme_function($function, $data) {

	if ($function == 'displayhtml') {
		if ($data == 'open')
			functions_html_adjust();
	}
}

/* adjust $html data (title, description) based on "location" */

// title can be confusing
// root: config(title) / config(subtitle)
// nonroot: config(title) / section(name) / section(subtitle)
// post/page:
// root: config(title) / record(title)
// nonroot: config(title) / section(name) / record(title)

function functions_html_adjust() {

	$op = getvar('op');
	$arg = config('arg');
	$section = config('section');

	if ($op == 'post' || $op == 'page') {
		$id = getvar('id');
		if ($op == 'post')
			$record = readrecord($id,NULL,TRUE);
		else
			$record = readfilerecord($id,TRUE);
		$title = $section['name'].html('titlesep').$record['title'];
		if (config('arg') == 'root')
			$title = $record['title'];
		if (isset($record['description']))
			$description = $record['description'];
		else
			$description = $record['title'];
	}
	else
	if ($op == 'help') {
		$title = 'HELP'.html('titlesep').config('subtitle');
	}
	else
	if ($arg == 'root') {
		$title = config('subtitle');
	}
	else {
		$title = $section['name'];
		if (isset($section['subtitle']))
			$title .= html('titlesep').$section['subtitle'];
	}

	html('title',html('title').html('titlesep').$title);
	if (isset($description))
		html('description',$description);
}
