<?php

/* See TEMPLATES.TXT and DOC/README.HTML#TEMPLATES. */

/* These are "first level" templates, those that need just one eval to resolve, 
generally, one that do not include other templates that reference data. See 
also the end of this file. See displayhtml() in MOD/DISPLAY.PHP. */

$html['direct'] = array(
'close',
'commentform',
);

/* Templates to cache by pre-evaluating. See end of this file. */

$html['cache'] = array(
'commenthelp',
);

/* These are special case versions of 'menu' when viewing individual things. */
// see htmlmenu() is MOD/HTML.PHP

$html['menus']['post'] = <<<'HTML'
<a href='{$html['backurl']}' title='Go back to {$html['name']}.'>Back</a>
HTML;

$html['menus']['page'] = <<<'HTML'
<a href='{$html['backurl']}' title='Go back to {$html['name']}.'>Back</a>
HTML;

$html['menus']['submit'] = <<<'HTML'
<a href='{$html['cancelurl']}' title='Cancel commenting.'>Cancel</a>
HTML;

/* The "sidebar", part of 'open'. */

$html['navmenu'] = <<<'HTML'
<div id="navmenu">
Sections
<ul>
{$html['navstra']}
</ul>
Other
<ul>
<li><a href="doc/readme.html" title="README">README</a></li>
</ul>
</div>

HTML;

/* The formal templates, in alphabetical order. */

$html['close'] = <<<'HTML'
<!-- close (default) -->
</div> <!-- content -->
</div>
<div id="footer">
<span>{$html['title']}</span>
<span id="copyright">
<a href="{$config['siteurl']}" title='{$config['subtitle']}'>{$config['sitename']}</a> {$config['copyright']}
</span>
</div>
<div id="debug">{$GLOBALS['debug_messages']}</div>
</body>
</html>
HTML;

$html['end'] = <<<'HTML'
<!-- end (default) -->
<!-- a minimal (no footer) of close for previewing comments and posts -->
</div> <!-- content -->
</div>
<div style="top-margin:20px;">&nbsp;</div>
</body>
</html>
HTML;

$html['entries'] = <<<'HTML'
<!-- entries (default) -->
<div class="entry" id="{$record['id']}">
<header>
<h1 class="title"><a href="{$record['post']}" title="view post: {$record['title']}">{$record['title']}</a></h1>
<time datetime="{$record['datetime']}">{$record['date']}</time>
</header>
<div class="body">
{$record['body']}
<div class="murl" title="view entire post">{$record['murl']}</div>
<div class="curl" title="view comments">{$record['curl']}</div>
</div>
</div>

HTML;

/* entries "no view" - a post with header 'noview:' */

$html['entries_n'] = <<<'HTML'
<!-- entries_n (default) -->
<div class="entry" id="{$record['id']}">
<header>
<h1 class="title"><a>{$record['title']}</a></h1>
<time datetime="{$record['datetime']}">{$record['date']}</time>
</header>
<div class="body">
{$record['body']}
</div>
</div>

HTML;

$html['entry'] = <<<'HTML'
<!-- entry (default) -->
<div class="entry">
<header>
<h1 class="title"><a href="{$record['post']}"
title="permanent link to {$record['title']}">{$record['title']}</a></h1>
<time datetime="{$record['datetime']}">{$record['date']}</time> {$html['gotocomments']}
</header>
<div class="body">
{$record['body']}
</div>
{$html['gototop']}
</div>

HTML;

$html['error'] = <<<'HTML'
<!-- error (default) -->
<div class="entry">
<header>
<h1 class="title">{$error['title']}</h1>
</header>
<div class="body">
{$error['message']}
</div>
</div>

HTML;

$html['postnotfound'] = <<<'HTML'
<!-- postnotfound (default) -->
<div class="entry">
<header>
<h1 class="title">Post Not Found</h1>
</header>
<div class="body">
The requested post was not found. It has either moved or been removed.
</div>
</div>

HTML;

$html['head'] = <<<'HTML'
<!DOCTYPE html>
<!-- head (default) -->
<!-- a minimal (no header) of open for previewing things -->
<html>
<head>
<title>{$html['title']}</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<link href="{$config['siteurl']}{$html['themedir']}default.css" rel="stylesheet" type="text/css">
</head>
<body>
<div id="main">
<div style="top-margin: 20px;">&nbsp;</div>
<div id="content">

HTML;

$html['open'] = <<<'HTML'
<!DOCTYPE html>
<!-- open (default) -->
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<meta name="description" content="{$html['description']}">
<title>{$html['title']}</title>
<link href="{$html['themedir']}default.css" rel="stylesheet" type="text/css">
</head>
<body id="top">
<div id="header">
<a href="{$config['siteurl']}" title='{$config['subtitle']}'>{$config['sitename']}</a>
</div>
{$html['navmenu']}
<div id="main">
{$html['menu']}
<div id="content">
HTML;

$html['page'] = <<<'HTML'
<!-- page (default) -->
<div class="entry">
<header>
<h1 class="title"><a href="{$record['post']}" title='permanent link to {$record['title']}'> {$record['title']}</a></h1>
</header>
<br>
<div class="body">
{$record['body']}
</div>
</div>

HTML;

/* The comment related templates. */

$html['nocomments'] = <<<'HTML'
<!-- nocomments (default) -->
<div class="comment">
There are no comments.
</div>
<br>

HTML;

$html['comment'] = <<<'HTML'
<!-- comment (default) -->
<div class="comment" id="{$record['id']}">
<b>{$record['title']}</b> from <b>{$record['from']}</b> {$record['date']}<br>
{$record['body']}
</div>

HTML;

$html['commentsintro'] = <<<'HTML'
<!-- commentsintro (default) -->
<div class="commentform" id="comments">
Comments:
</div>

HTML;

$html['commentsmax'] = <<<'HTML'
<!-- commentsmax (default) -->
<div class="commentform">
Maximum number of comments reached.
</div>

HTML;

$html['commentpreview'] = <<<'HTML'
<!-- commentpreview (default) -->
<div class="commentform" id="comments">
Comment Preview:
</div>

HTML;

$html['commentform'] = <<<'HTML'
<!-- commentform (default) -->
<div class="commentform">
{$html['commenthelp']}
<form name="commentadd" method="post" action="{$html['formurl']}">
<div class="commenttitle">Add Comment:</div>
<input class="{$html['formsubmit']}" {$html['formsubmit']} type="submit" name="button" value="submit">
<input type="submit" name="button" value="preview">
<input class="{$html['formcancel']}" {$html['formcancel']} type="submit" name="button" value="cancel"><br>
<label>
<input type="text" class="{$html['hidefrom']}" name="from" value="{$_POST['from']}" size=30 maxlength=32>
{$html['fromlink']}<br>
</label>
<label>
<input type="text" name="title" value="{$_POST['title']}" size=30 maxlength=64>
{$html['titlelink']}<br>
</label>
<label class="{$html['hidecode']}">
<input type="text" name="code" value="{$_POST['code']}" size=30 maxlength=32>
Code<br>
</label>
<textarea name="comment">{$_POST['comment']}</textarea>

<div class="note" style="margin-bottom: 10px;">
No Cookies, Javascript, or "Registering" required.
Formatting: *<b>bold</b>* ^<i>italic</i>^ _<u>underline</u>_ '<code>code</code>'.
<br>All HTML will be stripped and there is a {$config['postlimit']} byte limit.
</div>

<input class="{$html['formsubmit']}" {$html['formsubmit']} type="submit" name="button" value="submit">
<input type="submit" name="button" value="preview">
<input class="{$html['formcancel']}" {$html['formcancel']} type="submit" name="button" value="cancel">

<span style="color:red;">{$html['comment_message']}</span>
</form>
</div>

HTML;

# this is kind of stupid, actually, but the code *is* really small...

$html['moreprev'] = <<<'HTML'
<div style="text-align:center">
<span class="right" style="visibility:{$html['more_vis']};"><a href="{$html['argurl']}&amp;start={$html['count']}" rel="nofollow" title="view more posts">MORE</a></span>
{$html['gototop']}
<span class="left" style="visibility:{$html['prev_vis']};"><a href="{$html['argurl']}&amp;start={$html['start']}" rel="nofollow" title="view previous posts">PREV</a></span>
</div>
HTML;

$html['helpnotfound'] = <<<'HTML'
<div class="helptext">
The requested help file is missing.
</div>
HTML;

/*
   The logout/login forms. (These are going to be replaced by something 
   completely different.)
*/

$html['logoutform'] = <<<'HTML'
<div id="logout">
<form method="post" action="{$html['logouturl']}">
{$html['logoutstr']}
<input type="submit" name="button" value="logout">
<input type="hidden" name="redirect" value="{$html['redirect']}">
</form>
</div>

HTML;

$html['loginform'] = <<<'HTML'
<div id="login">
<form method="post" action="{$html['loginurl']}">
{$html['loginstr']}
name <input type="text" name="name" title="name">
code <input type="password" name="code" title="code">
<input type="submit" name="button" value="login">
<input type="hidden" name="redirect" value="{$html['redirect']}">
</form>
</div>

HTML;

$html['logoutlink'] = <<<'HTML'
<span id="logoutlink"><a href="{$html['logouturl']}" title="logout (delete cookie)">logout</a></span>
HTML;

/*
   "Visitor code" is optional
*/

if (config('visitorcode')) {

$html['commenthelp'] = <<<'HTML'
<div class="helptext">
<span>
<span class="help" style="cursor:default;"></span>
<div><small>
<p>Anyone is allowed to comment.</p>
<p><u>Username</u> and <u>{$html['titlelink']}</u> are optional. If cookies are enabled an entered <u>Username</u> will be remembered.</p>
<p><u>Code</u> is optional and is to allow you to associate the username with the code; once saved only you can post using your chosen username. See <a href="{$html['codeurl']}" target="_blank">code</a> for more.</p>
<p>All HTML will be stripped.</p>
<p>HTTP links and email addresses will not be allowed. Attempts to enter them will be logged and excessive attempts will cause you to be banned from accessing this website.</p>
</small></div>
</span>
</div>
HTML;

} else {

$html['commenthelp'] = <<<'HTML'
<div class="helptext">
<span>
<span class="help" style="cursor:default;"></span>
<div><small>
<p>Anyone is allowed to comment.</p>
<p><u>{$html['fromlink']}</u> and <u>{$html['titlelink']}</u> are optional. If cookies are enabled an entered <u>{$html['fromlink']}</u> will be remembered.</p>
<p>All HTML will be stripped.</p>
<p>HTTP links and email addresses will not be allowed. Attempts to enter them will be logged and excessive attempts will cause you to be banned from accessing this website.</p>
</small></div>
</span>
</div>
HTML;

}

/* This is a way to "pre evaluate" a template, not too unlike a cache. */

	if (isset($html['cache']) && is_array($html['cache']))
		foreach ($html['cache'] as $h)
			if (isset($html[$h])) {
				$text = $html[$h];
				eval(_textset('text',$text)); // MOD/DISPLAY.PHP
				$html[$h] = $text;
			}

/*
This code can be greatly improved even still by making the templates have META 
data, like:

$template['name'] = array(
'precache' => TRUE,
'body' => '
<p>Place HTML and references here.</p>',
);

Which is just an example, but something that can make all this even cooler...
*/
