<?php

/* HTM/WP/FUNCTIONS.PHP - theme code

   This code gets called late by INDEX.PHP but before anything gets displayed.

   In this example the code creates the WordPress theme's sidebar -- the 
   $html['navmenu'] HTML.

   This is just a small example of what can be done.

*/

/* self initialize */

_functions_config();


/*
   We put the initialization code within a function so as to not have to 
   worry about polluting the global namespace.
*/

define('LATEST_POSTS',3);
define('LATEST_PAGES',2);

function _functions_config() {

	$op = getvar('op');
	$id = getvar('id');

	if ($op && $op != 'read') {
		if ($id) {
			$record = readrecord($id);
			html('record',$record);	// store post/page data
		}
		html('navmenu','');		// eliminate default menu
		return;
	}

	// only create the side bar when viewing the main page

	$html = '<div id="sidebar">';
	$ids = dblistrecords();
	if ($ids) {
		rsort($ids);
		$html .= '<h3>LATEST POSTS</h3><ul>';
		$c = 0;
		foreach ($ids as $id) {
			$url = make_url('post',$id);
			$h = readrecord($id,NULL,TRUE);
			$html .= "<li><a href='$url'>{$h['title']}</a></li>";

			if (++$c == LATEST_POSTS)
				break;
		}
		$html .= '</ul>';
	}
	$ids = dblistpages();
	if ($ids) {
		$html .= '<h3>PAGES</h3><ul>';
		$c = 0;
		foreach ($ids as $id) {
			$url = make_url('page',$id);
			$h = dbgetpageheaders($id);
			$html .= "<li><a href='$url'>{$h['title']}</a></li>";

			if (++$c == LATEST_PAGES)
				break;
		}
		$html .= '</ul>';
	}

	$html .= '</div>';
	html('navmenu',$html);

/*
   We never got around to other "widgets" WP has. For some of the other 
   things WP lists we would need to create a database table of for storing 
   such meta data as they do. Not all that difficult of course, we are just 
   lazy...
*/

}
