<?php

/* just a few goofy functions to do odd things */

function htmlentitieize(&$data) {

	if (is_array($data)) {
		foreach ($data as &$d)
			$d = htmlentities($d,ENT_QUOTES);
	}
	else
		$data = htmlentities($data,ENT_QUOTES);
}

function strip_errtags($s) {

	$s = str_replace(array('<br />','<b>','</b>',"\n"),'',$s);
	return str_replace($_SERVER['DOCUMENT_ROOT'],'',$s);
}

// we have found that sometimes an error occurs that does NOT get returned 
// by error_get_last(); see use of parse_ini_string() in ADMIN.PHP

function php_error(&$file = NULL, &$line = NULL) {

	$e = error_get_last();
	$s = $e['message'];
	if (ini_get('html_errors'))
		$s = preg_replace('/ \[.*\]:/','',$s);
	$file = basename($e['file']);
	$line = $e['line'];

	return $s;
}

function strip_htmlcomments($s) {
	return preg_replace('/<!--.*-->/','',$s);
}

function array_delete(&$array, $value) {

	foreach ($array as $a => $b) {
		if ($b == $value) {
			unset($array[$a]);
			break;
		}
	}
}

function my_glob($dir, $ext = '') {

	$files = glob($dir);
	$files = str_replace(dirname($dir).'/','',$files);
	if ($ext) $files = str_replace($ext,'',$files);
	return $files;
}

function print_e($a, $c = ', ') {

	echo rtrim(implode($c,$a),$c);
}

function collapse($a, $no = 40) {

	$s = '';
	foreach ($a as $k => $v) {
		$v = htmlentities((!$no) ? $v : substr($v,0,$no));
		$s .= "<b>$k=</b>'$v' ";
	}
	return $s;
}

function parray($a) {

	if (isset($a[0]))
		echo implode('<br>',$a);
	else
	foreach ($a as $k => $v)
		echo "$k = $v<br>";
}

// from comment on php.net

function randomstring($len) {
$s = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';

	return substr(str_shuffle($s),0,$len);
}

// we keep doing something like this so let's make it a function

function ob_run($func, $a, $b, &$out) {

	ob_start();
	$r = $func($a,$b);
	$out = ob_get_contents();
	ob_end_clean();
	return $r;
}

/* getcaller - get who called the caller */

// list($file,$line,$func) = getcaller();
// print "file: $file, line: $line, function: $func";

// this is a real handy function for helping track execution flow
// (sometimes the file and line numbers are not known to PHP; like 
// via call_user_func())

// best use is:
// 	list($file,$line,$func) = caller(1);
// 	$func = caller(2,'function');
// which gets the correct function that called

// but if you want a function to return who called use this:

function getcaller(&$file, &$line, &$func) {

	list($file,$line,$func) = caller(2);
	$func = caller(3,'function');
	return "called: $file,$line,$func";
}

// did this twice so functioned it; then just once... oh well

function splitntrim($string, $delim = ',') {

	$a = array();
	foreach (explode($delim,$string) as $s)
		$a[] = trim($s);
	return $a;
}

// is_empty - true if var is "empty"

// this is because PHP's empty treats "0" as empty, and PHP's is_null() does 
// not think that "" is null (which it ain't of course), but we want to 
// detect "" as not correct and "0" as okay

function is_empty($v) {

	return ($v === "" || is_null($v));
}


// identify - useful for learning how PHP does things (for us neophytes)

function identify($var) {

	print "<tt>";
	print "$var<br>";
	if (!$var) print "!<br>";
	if (!isset($var)) print "!"; print "isset<br>";
	if (!is_null($var)) print "!"; print "is_null<br>";
	if (!is_empty($var)) print "!"; print "is_empty<br>";
	if (!is_numeric($var)) print "!"; print "is_numeric<br>";
	if (!is_array($var)) print "!"; print "is_array<br>";
	print ($var === 0) ? "===" : "!=="; print " 0<br>";
	print ($var === "") ? "===" : "!=="; print " \"\"<br>";
	print ($var === NULL) ? "===" : "!=="; print " NULL<br>";
	print ($var === TRUE) ? "===" : "!=="; print " TRUE<br>";
	print ($var === FALSE) ? "===" : "!=="; print " FALSE<br>";
	print ($var === array()) ? "===" : "!=="; print " array()<br>";
	print "<br><br></tt>";
}
