<?php

/* CONVERT.PHP - comment text is "translated" through here 

Comments are converted before they are written to the database (posts are 
editable, comments are not). This is more API than module but it references 
configuration data.

convert_user($body);			// comment text
*/


/* convert_user - conversions on comment body */

// there are fewer translations for comments
// this code needs updating to allow more formatting

function convert_user($data) {

	$filter = config('commentfilter');
	$tags = config('commenttags');
	$atags = explode_tags($tags);		// array of tags

	if (!$filter)
		$data = my_strip_tags($data);
	if (!config('commententities'))
		$data = str_replace('&','&amp;',$data);

	$data = explode("\n",$data);

	// do this line by line to get the paragraphing right (with <p></p>) 
	// it is inefficient but not too inefficient to not do it that way
# it can get misplaced allowed tags wrong though

	$body = '';
	while (list( ,$_) = each($data)) {
		if ($_ == '') continue;

		if ($filter == 'striptags')
			$_ = our_strip_tags($_,$tags,$atags);
		else
		if ($filter == 'specialchars')
			$_ = htmlspecialchars($_,ENT_NOQUOTES);
		else
			$_ = convertchars($_);			// ' * ^ | _

		$body .= '<p>'.$_.'</p>'."\n";
	}

	return rtrim($body);
}

/* convertchars - character translations */

function convertchars($str) {

	if (config('entitytranslate'))
		gmlp_entities($str);
	gmlp_chars($str);

	return $str;
}

/* my_strip_tags - strip_tags() is a little sloppy, this fixes it somewhat */

function my_strip_tags($s) {

	$s = preg_replace('/<\s+/','<',$s);	// strip_tags() errs if ' '
	$s = strip_tags($s);			// can leave behind errant '>'s
	return str_replace('>','',$s);
}

/* our_strip_tags - fix un-closed tags per line */

// stray end tags don't seem to be a problem with most web browsers

function our_strip_tags($_, $tags, $tagsarray) {

	$_ = preg_replace('/<\s+/','<',$_);
	$_ = strip_tags($_,$tags);

	if ($tags) {
		foreach ($tagsarray as $a => $b) {
			$A = substr_count($_,$a);	// count and
			$B = substr_count($_,$b);
			while ($A > $B++)		//  append if missing
				$_ .= $b;
		}
	}

	return $_;
}

/* explode_tags -  "<a><b>" to array("<a>"=>"</a>","<b>"=>"</b>") */

function explode_tags($tags) {
static $atags = array();

	if (!$tags)
		return array();
	
	if ($atags !== array())
		return $atags;

	$a = explode('>',$tags);
	array_pop($a);
	foreach ($a as $t)
		$atags[$t.'>'] = preg_replace('/<(.*)/','</$1>',$t);

	return $atags;
}
