<?php

/* USERCODE.PHP - manage "user" added code

"usercode" is code attached to a record and is 'eval'ed during the record 
(post) display process. You will probably not understand how it works by 
just looking at this code. Trust me. Yet it does work. 

Verion 1.4.1:
This code is GOING TO BE CHANGED. It will retain the same way the user code is 
invoked, just how the user code is created will be supplemented to support a 
normal PHP source file.

See file USERCODE.
*/


/* module initialize function */

function _config_usercode() {
	_usercode();
}


/* usercode - apply usercode to a post */

// can change $record; called solely by displayrecord() in DISPLAY.PHP

function usercode(&$record) {

	if (isset($record['usercode']))
		usercode_call($record['usercode'],$record);

	if (_usercode('allposts') && !isset($record['noall']))
		usercode_call('allposts',$record);
}


/* usercode_call - use external code to post-process a record */

// this runs fairly deep before it may realize that there is no user code,
// not too bad though...

function usercode_call($codeid, &$record) {

	if (strstr($codeid,',')) {
		$user_args = splitntrim($codeid);
		$codeid = $user_args[0];
	}
	else
		$user_args[0] = $codeid;

	$uc = _usercode($codeid);			// get the usercode
	if ($uc === FALSE) {
		$umsg = "usercode:'$codeid' not found";
		if (config('showusercodeerr'))
			$record['body'] .= "<div class='note'>$umsg</div>";
		else
			$record['body'] .= "<!-- $umsg -->";
		debug("'$codeid' not found");
		return;
	}

	$r = $uc($user_args,$record);			// call usercode
	debug("'$codeid'");

	if ($r)						// okay, use result
		$record['body'] = $r;
}


/* usercode_global - apply any '[global]' usercode */

// called once when this module is included

function usercode_global() {

	if (stristr($GLOBALS['VERSION'],'admin'))
		return;

	$uc = _usercode('global');

	if ($uc) {
		$r = $uc();
		debug('global:'.$r);
	}
}


/* _usercode - set/get user code code string */

function _usercode($codeid = '') {
static $init = 0;
static $user_code = array();

	if (!$init) {
// the use of $init is that $user_code can be left uninitialized if there is 
// no usercode
		$init = 1;
		if (config('nousercode'))
			return;

		$file = themedir('usercode.ini');
		$code = (is_file($file)) ? datafile($file) : array();

		$record = recordcreate('test','test');
		$args = '$user_args,$record';
		foreach ($code as $name => $code) {
			if (check_usercode($code,$error) == FALSE) {
				debug("'$name' $error");
				continue;
			}
			if (@eval($code) === FALSE) {
				$e = php_error($f,$l);
				debug("'$name' $e, line $l");
				continue;
			}
			debug("'$name'");
			if ($name == 'global')
				$f = create_function('',$code);
			else
				$f = create_function($args,$code);
			$user_code[$name] = $f;
		}

		usercode_global();
	}

	if (config('nousercode') || !isset($user_code[$codeid]))
		return FALSE;

	return $user_code[$codeid];
}


/* parse_usercode - fail on non-existing functions and non-allowed keywords */

// used by Admin for "parse" button when editing usercode.ini

function parse_usercode($data) {

// there is some code duplication here and in _usercode(); we will fix it...

	$code = datafile($data,1);
	$record = recordcreate('test','test');
	$args = '$user_args,$record';
	foreach ($code as $name => $code) {
		if (check_usercode($code,$error) == FALSE) {
			return "[$name] $error";
		}
		if (@eval($code) === FALSE) {
			$e = php_error($f,$l);
			return "[$name] $e, line $l";
		}
	}

	return 'okay!';
}


/* check_usercode - try to parse code for errors */

function check_usercode($code, &$error) {

$constructs = array('isset', 'empty', 'unset', 'if', 'else', 'elseif', 'while', 'for', 'foreach', 'do-while', 'switch', 'declare', 'return', 'print', 'echo', 'eval', 'include', 'require', 'include_once', 'require_once');
$shouldnts = array('goto', 'print', 'echo', 'eval', 'include', 'require', 'include_once', 'require_once', 'function');
$re = '/\W([a-zA-Z_]+)\(.*\)/';

	preg_match_all($re,$code,$res);
	if (isset($res[1])) {
		foreach ($res[1] as $f) {
			if (!in_array($f,$constructs) && !function_exists($f)) {
				$error = "$f is not a function";
				return FALSE;
			}
		}
	}
	foreach ($shouldnts as $keyword) {
		if (strpos($code,$keyword) !== FALSE) {
			$error = "$keyword is not allowed";
			return FALSE;
		}
	}

	return TRUE;
}
