<?php

// TRANSLATE.PHP - See file GMLP for full description. This data is meant 
// to be modified/customized.

$gmlp_translate['entitytranslate'] = 1;

// skip lines

$gmlp_translate['skip'] = array(
"/^`(.*)'$/",
);

// convert line to pragraph and then continue (but see file GMLP)
// if value is '' use line as is; if value is function, line is function 
// result; else line is preg replaced -- first two conditions bypass all 
// further conversions

$gmlp_translate['lines'] = array(
'/^(<hr>)/' => '',
'/^<!--.*-->$/' => '',
'/^\/\/.*/' => 'gmlp_pre',
'/^[A-Z \/&\?\'!]+$/' => 'gmlp_h2',
'/^\s{9,}(.*)/' => '<span style="display:block;text-align:center;">$1</span>',
'/^<(indent|box|message|notice|note|small|center)>/' => '<div class="$1">',
'/^<\/(indent|box|message|notice|note|small|center)>/' => '</p></div>',
'/^~$/' => '<div class="tilde">~</div>',
'/^h([1-6]):\s*(.*)/' => '<h$1>$2</h$1>',
'/^bq:\s*(.*)/' => '<blockquote>$1</blockquote>',
'/^in:\s*(.*)/' => '<div style="text-indent:2em;">$1</div>',
'/^nt:\s*(.*)/' => '<div style="font-size:smaller;">$1</div>',
'/^cn:\s*(.*)/' => '<div style="text-align:center;">$1</div>',
);

// the following three occur in order for all subsequent lines

// this one can happen twice in two separate places

$gmlp_translate['line'] = array(
'/^\t(.*)/' => '        $1',
);


// preg replaces - for functions only $1 is passed to it, which is going to 
// change next release (the matches array will be passed); these are applied 
// in order so one can effect another

$gmlp_translate['inlines'] = array(
'/(\S+)\[\]([,. \)]+)/' => '$1<span class="nt"></span>$2',
'/(\S+)\[\]$/' => '$1<span class="nt"></span>',
'/`([^\']*)\'/U' => '<tt>`$1\'</tt>',
'/(http[s]*:\/\S*)(:)([a-zA-Z0-9 ?_]+)/' => '<a href="$1">$3</a>',
'/""(.*)""/U' => '<em>"$1"</em>',
'/([A-Z_\/]+\.(INI|TXT|HTML|HTM|PHP)+)/' => '<code>$1</code>',
// these avoid other translations
'/\(\'([a-zA-Z ]*)\'\)/' => '(&#039;$1&#039;)',
'/\\\\\$/U' => '&#036;',
'/\\\\\'/U' => '&#039;',
'/\\\\\./U' => '&#046;',
// these values are function calls
'/(<[A-Z]+>)/' => 'gmlp_htmlstr',
'/(<\/[A-Z]+>)/' => 'gmlp_htmlstr',
'/\'\'(.*)\'\'/U' => 'htmlentities',
'/%([a-zA-Z]+)%/U' => 'config',
'/!([a-zA-Z]+)!/U' => 'html',
// NOTE: the order of these are important! (see PHP string comment EOF)
'/([a-zA-Z_]+\([^\)]*\))/' => 'gmlp_php_string',
'/(\$[0-9]+)/' => 'gmlp_php_string',
'/(\$[^ .,;]+)/' => 'gmlp_php_string',
);

// string substitutions

$gmlp_translate['entities'] = array(
'--' => '&mdash;',
);

// tag-ize words

$gmlp_translate['chars'] = array(
'*' => 'b',
'_' => 'u',
'|' => 'tt',
'^' => 'i',
'\'' => 'code',
);

// block conversions - see file GMLP

$gmlp_translate['blocks']['leadingspace'] = array(
'begin' => '/^\s{1,8}/',
'end' => '/(^\S+|^$)/',
'pre' => '<pre>',
'replace' => 'htmlentities',			// function call on each line*
'post' => '</pre>',
'first' => 1,
'continue' => 1					// retain end line
);
// * not as efficient as applying the call to the entire block, but 'post' 
// has dual role: function or string

$gmlp_translate['blocks']['php'] = array(
'begin' => '/^\s*<\?php/',			// begin tag (RE)
'end' => '/^\s*\?>/',				// end tag
'post' => 'gmlp_highlightstr',			// function call on block
'first' => 1,					// include begin line
'last' => 1,					// include end line
);

$gmlp_translate['blocks']['php2'] = array(
'begin' => '/^<php>/',
'end' => '/^<\/php>/',
'newline' => 1,
'post' => 'gmlp_highlightstr_php',
);

$gmlp_translate['blocks']['pre'] = array(
'begin' => '/^<pre/',				// note lack of '>' *
'end' => '/^<\/pre>/',
'first' => 1,
'last' => 1,
'newline' => 1,
);
// * so <pre class="foo"> will work; something experimental

$gmlp_translate['blocks']['html'] = array(
'begin' => '/^<html>/',
'end' => '/^<\/html>/',
'pre' => '<pre>',
'post' => '</pre>',
'newline' => 1,
'replace' => 'htmlentities',
);

$gmlp_translate['blocks']['skip'] = array(
'begin' => '/^``/',
'end' => '/^\'\'/',
'pre' => '<p>',
'post' => '</p>',
'replace' => '<br>',				// append to each line
);

$gmlp_translate['blocks']['comment'] = array(
'begin' => '/^<!--/',
'end' => '/^-->/',
'first' => 1,
'last' => 1,
);

$gmlp_translate['blocks']['phpcomment'] = array(
'begin' => '/^\/\*/',
'end' => '/^\*\//',
'pre' => "<pre>/*\n",
'post' => '</pre>',
'last' => 1,
);

$gmlp_translate['blocks']['list'] = array(
'begin' => '/^<list>/',
'end' => '/^<\/list>/',
'pre' => '<ul>',
'post' => '</ul>',
'replace' => 'gmlp_list',
'convert' => 1,				 
);

$gmlp_translate['blocks']['ul'] = array(
'begin' => '/^<ul>/',
'end' => '/^<\/ul>/',
'pre' => '<ul>',
'post' => '</ul>',
'replace' => 'gmlp_list',
'convert' => 1,				 
);

$gmlp_translate['blocks']['dl'] = array(
'begin' => '/^<dl>/',
'end' => '/^<\/dl>/',
'first' => 1,
'last' => 1,
'replace' => 'gmlp_dlist',
'convert' => 1,				 
);

$gmlp_translate['blocks']['notes'] = array(
'begin' => '/^<notes>/',
'end' => '/^<\/notes>/',
'pre' => '<b><small>Notes</small></b><ol class="notes">',
'post' => '</ol>',
'replace' => 'gmlp_list',
'convert' => 1,				 
);

$gmlp_translate['blocks']['insert'] = array(
'begin' => '/^<insert>/',
'end' => '/^<\/insert>/',		 
'pre' => '<pre class="insert">',
'post' => '</pre>',
);

$gmlp_translate['blocks']['ini'] = array(
'begin' => '/^<ini>/',
'end' => '/^<\/ini>/',
'replace' => 'gmlp_ini',
'pre' => '<pre class="ini"><span style="display:none">INI text</span>',
'post' => '</pre>',
'newline' => 1,
);

$gmlp_translate['blocks']['code'] = array(
'begin' => '/^<code>/',
'end' => '/^<\/code>/',
'post' => 'gmlp_div_highlightstr_php',
'newline' => 1,
);

$gmlp_translate['blocks']['text'] = array(
'begin' => '/^<text>/',
'end' => '/^<\/text>/',
'pre' => '<pre class="text"><span>plain text</span>',
'post' => '</pre>',
'replace' => 'htmlentities',
);

$gmlp_translate['blocks']['blockquote'] = array(
'begin' => '/^<blockquote/',
'end' => '/^<\/blockquote>/',
'first' => 1,
'last' => 1,
'convert' => 1,
);

$gmlp_translate['blocks']['div'] = array(
'begin' => '/^<div/',
'end' => '/^<\/div>/',
'first' => 1,
'last' => 1,
'convert' => 1,
);

$gmlp_translate['blocks']['quote'] = array(
'begin' => '/^<quote>/',
'end' => '/^<\/quote>/',
'pre' => '<blockquote>',
'post' => '</blockquote>',
'convert' => 1,
'replace' => '<br>',
);

/*
   In order to enter lots of HTML, put it between <HTML> tags -- this causes 
   all lines to be used "as is".
*/

$gmlp_translate['blocks']['HTML'] = array(
'begin' => '/^<HTML>$/',
'end' => '/^<\/HTML>/',
);

// same as:

$gmlp_translate['blocks']['notranslate'] = array(
'begin' => '/^<notranslate>$/',
'end' => '/^<\/notranslate>/',
);

return 1;

/*
PHP strings
These just show how to make the code appear to be "smart" by highlighting PHP 
function calls and strings embedded in text:

       $2		special PHP PCRE variables
       $foo		PHP variable
       foobar()		PHP function calls
*/
